<template>
  <div class="flex flex-column flex-auto">
    <div class="surface-section p-5">
      <div
        class="flex align-items-start flex-column lg:flex-row lg:justify-content-between"
      >
        <div class="flex align-items-start flex-column md:flex-row">
          <img
            :src="data?.user.avatar_url"
            class="mr-5 mb-3 lg:mb-0 border-circle"
            style="width: 90px; height: 90px"
          />
          <div>
            <span class="text-900 font-medium text-3xl">
              <a :href="data.user.web_url" target="_blank">{{
                data.user.name
              }}</a>
            </span>
            <div class="flex align-items-center flex-wrap text-sm">
              <div class="mr-5 mt-3">
                <span class="font-medium text-500">CONTRIBUTIONS</span>
                <div class="text-700 mt-2">{{ contributions.length }}</div>
              </div>
              <div class="mr-5 mt-3">
                <span class="font-medium text-500">COMMITS</span>
                <div class="text-700 mt-2">
                  {{ categorizedContributions.push.length }}
                </div>
              </div>
              <div class="mr-5 mt-3">
                <span class="font-medium text-500">COMMENTS</span>
                <div class="text-700 mt-2">
                  {{ categorizedContributions.comments.length }}
                </div>
              </div>
              <div class="mt-3">
                <span class="font-medium text-500">APPROVED MRS</span>
                <div class="text-700 mt-2">
                  {{ categorizedContributions.approvedMRs.length }}
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="p-5">
      <div class="grid">
        <Stats
          title="Opened Issues"
          :value="categorizedContributions.openedIssues.length"
          icon-color="text-yellow-500"
          icon="pi-folder-open"
        ></Stats>
        <Stats
          title="Closed Issues"
          :value="categorizedContributions.closedIssues.length"
          icon-color="text-cyan-500"
          icon="pi-folder"
        ></Stats>
        <Stats
          title="Opened MRs"
          :value="categorizedContributions.openedMrs.length"
          icon-color="text-orange-500"
          icon="pi-lock-open"
        ></Stats>
        <Stats
          title="Closed MRs"
          :value="categorizedContributions.closedMRs.length"
          icon-color="text-indigo-500"
          icon="pi-lock"
        ></Stats>

        <div class="col-12 xl:col-6">
          <div class="surface-card shadow-2 border-round p-4 h-30rem">
            <div class="text-xl text-900 font-medium mb-5">
              Authored MRs - {{ mrs.length }}
            </div>
            <MrTable :mrs="mrs"></MrTable>
          </div>
        </div>
        <div class="col-12 xl:col-6">
          <div class="surface-card shadow-2 border-round p-4 h-30rem">
            <div class="text-xl text-900 font-medium mb-5">
              Reviewed MRs - {{ reviews.length }}
            </div>
            <MrTable :mrs="reviews"></MrTable>
          </div>
        </div>
        <div class="col-12">
          <div class="border-round p-4">
            <div class="text-xl text-900 font-medium mb-5">Timeline</div>
            <ClientOnly fallback-tag="span" fallback="Loading timeline...">
              <Timeline
                :value="categorizedContributions.comments"
                align="alternate"
              >
                <template #opposite="{ item }">
                  <div class="">
                    {{ new Date(item.note.updated_at).toLocaleString() }}
                  </div>
                </template>
                <template #content="{ item }">
                  <Card class="mb-5">
                    <template #title>
                      Comment in: "{{ item.target_title }}"
                    </template>
                    <template #subtitle> </template>
                    <template #content>
                      <div class="line-height-3 text-700 mb-3 overflow-hidden">
                        {{ item.note.body }}
                      </div>
                    </template>
                  </Card>
                </template>
              </Timeline>
            </ClientOnly>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import Timeline from "primevue/timeline";
import Card from "primevue/card";

const route = useRoute();

const { data: data } = await useFetch(`/api/fetch/user/${route.params.id}`);

const mrs = computed(() => {
  return data.value?.mrs || [];
});

const reviews = computed(() => {
  return data.value?.reviewedMrs || [];
});

const contributions = computed(() => {
  return data.value?.contributions || [];
});

const categorizedContributions = computed(() => {
  return data.value?.categorizedContributions || {};
});
</script>
